public protocol Rules {
    // var state: GameState { get }

    // var history: [Move] { get }

    func createBoard() -> Board

    func isValid(board: Board) -> Bool

    func isValid(board: Board, move: Move) -> Bool

    func validMoves(board: Board) -> [Move]

    func validMoves(board: Board, for_player player: Player) -> [Move.Action]

    func gameState(board: Board, last_turn: Player?) -> GameState
    
    // mutating func onMoveDone(move: Move, board: Board) -> Void
}

public enum GameState: Equatable {
    case Playing(turn: Player)

    case Win(winner: Player, board: Board, cells: [Coords])
    
    case Draw
}
